#ifndef _S5_CPU_H
	#define _S5_CPU_H 1
	
	   struct Baustein_Infos
		{	bool vorhanden;
			int AnzahlNetzwerke;
		};
	
		struct StruturCode{
		int 	Code;
		char 	MarkeName[10];
		int   AusgabeZeileStatus;
		};
		
	struct StructBefehle {
			short Befehl;
			short Operand;
			short Wert;
			char  MarkeName[10];
		};
	
	struct StructProzess {
			bool  Bearbeitet;
			short Vek;
			short Inhalt;
			short Akku1;
			short Akku2;
		};
	   
	double ZeitRasterDouble(short Zeitraster);
 
	class CPU_sps
	{	public:
		void 	popStack(int Op,short wert);
		short pushStack(int &Op,short &wert);
		int SPS_Interpreter(int  BausteinName,int BausteinNr);
		bool TImpulse_LowToHighFlanke(short Nr,bool Signal);
		bool TImpuls_HighToLowFlanke(short Nr, bool Signal);
		bool Zaehler_SET_Impulse_LowToHighFlanke(short Nr,bool Signal);
		short SI_Timer64Bit(short Nr,short BCD_Zahl, bool Signal);
		short SI_Timer(short Nr, short BDC_Zahl, bool Signal);
		short SV_Timer(short Nr, short BDC_Zahl, bool Signal);
		short SE_Timer(short Nr, short BDC_Zahl, bool Signal);
		short SS_Timer(short Nr, short BDC_Zahl, bool Signal);
		short SA_Timer(short Nr, short BDC_Zahl, bool Signal);
		void Function_Reset_Timer(short Nr, bool Signal);
		short Zaehler_ZV(short Nr, bool Signal);
		short Zaehler_ZR(short Nr, bool Signal);
		unsigned int getBit(unsigned int Operand,unsigned int BitNr);
		void SetBit(unsigned int Operand,unsigned int BitNr,unsigned int Signal);
		short HexToDez(char *Hexzahl);
		void DezToHex(short Dez,char *Hexzahl);
		short BinToDez(char *Binzahl);
		void DezToBin(short Dez,char * ZahlenStr);
		short KT_DezToBCD(char *pChar);
		short KZ_DezToBCD(char *pChar);
		short BcdToDez(short BCD_Zahl);
		short DezToBcd(short Dezimal);
		short KT_BcdToDez(short BCD_Zahl,short &Zeit_Basis);
		short KZ_BcdToDez(short BCD_Zahl);
		short KyToZahl(char *ky_Zahl);
		void  ZahlToKy(short Dez,char *ky_Zahl);
		short Load(short Operand,short Nr);
		void ProzessabBild(short* Daten);
		void AG_Neustart();
		unsigned char  EByte[256];
		unsigned char  AByte[256];
		unsigned char  MByte[256];
		unsigned char  ZByte[256];
		unsigned char  TByte[256];
		short Z_KZ[256],Z_Stand[256],ZV_Flanke[256], ZR_Flanke[256];
		short T_KT[256],T_Input[256],TLaufZeit[256];
		double msTLaufZeit[256];			
		short Zeitraster[256],Reset_Timer[256],T_sperren[256];
		double msTimerStart[256];
		bool MTimerFlanke_LH[256],MTimerFlanke_HL[256];
		bool MZaehlerFlanke_LH[256];
		//unsigned int StatusZeile;short ZeitRegister;
		int StackPointer;
		int WStack[1000];
		int OStack[1000];
		short Alu,Bit_Register,Akku1, Akku2,zwSpeicher;
		bool AluLaden;
		int returnWertInterpreter;
		short Nr;
		bool AG_Stop;
		int Befehl,Operand,ZahlenWert,Inhalt;
		int BefehlsLaenge[512];
		CPU_sps(void);
		~CPU_sps(){};
	};
	
#endif
