#include "funktionen.h"
#include<string.h>
#include<stdio.h>
#include<stdlib.h>
#include<ctype.h>

void fast_SetBit(unsigned char &ByteNr, int BitNr)
{  ByteNr|=1 << BitNr;
}

void fast_ResetBit(unsigned char &ByteNr, int BitNr)
{  ByteNr&=~(1 << BitNr);
}

unsigned char fast_GetBit(unsigned char ByteNr, int BitNr)
{ return (ByteNr >> BitNr) &1;
}
 
void LeerzeilenEntfernen(char *pQuelle)
{	char *pTeilStr;
	int lenStr,AnzahlChar;
	pTeilStr=strtok(pQuelle,"\n");
	while(pTeilStr != NULL)
	{ 	lenStr=strlen(pTeilStr);
		AnzahlChar=strspn(pTeilStr," \t");
		if(lenStr!=AnzahlChar) // wenn nicht nur Leerzeichen und Tabzeichen
		{	memcpy(pQuelle,pTeilStr,lenStr);
			pQuelle+=sizeof(char)*lenStr;
			memcpy(pQuelle,"\n",1);
			pQuelle++;
		}
		pTeilStr=strtok(NULL,"\n");
	}//ENDE	while(pTeilStr != NULL)					
	*pQuelle=0;
}//ENDE LeerzeilenEntfernen




void InStringsZerlegenDurchNullen(char *CStr,char C)
{	char *pChar;
	strcat(CStr,"\r"); // Abschlußzeichen anhaengen
	pChar=strchr(CStr,C);
	while(pChar)
	{	*pChar=0;
		 pChar++;
		 if(pChar!=NULL)  pChar=strchr(pChar,C);
	}		
}//ENDE InStringsZerlegenDurchNullen(char *CStr)


char * GenullteStringsAusgeben(char *CStr)
{	static char *pChar=NULL;
	if(CStr!=NULL)
		pChar=CStr;
	else   
		pChar=strchr(pChar,0);		// Nächste Null suchen
	while(*pChar==0) pChar++;		// Nullen entfernen
	if(*pChar=='\r')
		return NULL;
	return pChar;
}//ENDE GenullteStringsAusgeben(char *CStr)


void StringLoeschen(char * pChar)
{	while(*pChar!=0 && *pChar!='\r')
	{  *pChar=0;
		 pChar++;
	}
}//ENDE StringLoeschen(char * pChar)


void AlleKomentareLoeschen(char * pChar)
{   while(*pChar!='\r')
	 { if(*pChar=='$')
		{	pChar++;
			while(*pChar!=0 && *pChar!='\r' )
			{  *pChar=0;
		 		pChar++;
			}
		}
	 	pChar++;
	 }
}


void ZeileToUpperBis_Dollar(char *CStr)
{ 	 while(*CStr>0 && *CStr!='$' )
	 {	*CStr=toupper(*CStr);
		CStr++;
    }
}//ENDE ZeileToUpper(char *CStr)

void ZeileToUpper(char *CStr)
{ 	 while(*CStr)
	 {	*CStr=toupper(*CStr);
		CStr++;
    }
}//ENDE ZeileToUpper(char *CStr)

void StrAusschneiden(char *Str,char vonZeichen,char bisZeichen,char *StrAusschnitt)
{	char *anChar,*endChar;
	long laenge=0;
	if(Str)
	{ 	anChar=strchr(Str,vonZeichen);
		endChar=strchr(Str,bisZeichen);
		if(anChar && endChar)
		{	laenge=(long(endChar)-long(anChar+(sizeof(char)*1)));
		strncpy(StrAusschnitt,anChar+(sizeof(char)*1),laenge);//laenge);	
		}
	}
	StrAusschnitt[laenge]='\0';
}//ENDE StrAusschneiden

void PfadDateiname_zerlegen(QString PfadPlusName, QString &Pfad, QString &Name)
{	int pos;
	pos=PfadPlusName.findRev('/',-1,false)+1;
	Pfad=PfadPlusName.left(pos);
	Name=PfadPlusName.mid(pos,80);
}

 
short KT_DezToBCD(char *pChar)
{	short BCD_Zahl;
	char *pZeitraster,BCD_Str[80];
	short l,n,Zahl;
	pZeitraster=strchr(pChar,'.');
	if(pZeitraster!=NULL)
	{ 		*pZeitraster=0;
		 	pZeitraster++;
			Zahl=atoi(pChar);
			sprintf(BCD_Str,"%s%03d",pZeitraster,Zahl);
	}
   l=strlen(BCD_Str)-1;
	BCD_Zahl=0;
	for(n=0;n<l;n++)
	{ 	 BCD_Zahl+=BCD_Str[n]-48;
		 BCD_Zahl<<= 4;
	}
	BCD_Zahl+=BCD_Str[l]-48;
	return BCD_Zahl;  // BCD_CODE
}//ENDE short KT_DezToBCD(char *pChar)

short KZ_DezToBCD(char *pChar)
{	short BCD_Zahl;
	char  BCD_Str[80];
	short l,n,Zahl;
	if(pChar!=NULL)
	{   Zahl=atoi(pChar);
		 sprintf(BCD_Str,"%04d",Zahl);
	}
   l=strlen(BCD_Str)-1;
	BCD_Zahl=0;
	for(n=0;n<l;n++)
	{ 	 BCD_Zahl+=BCD_Str[n]-48;
		 BCD_Zahl<<= 4;
	}
	BCD_Zahl+=BCD_Str[l]-48;
	return BCD_Zahl;  // BCD_CODE
}

void ZeichenEntfernen(char *pStr,char c)
{	char zwStr[256];
	int i=0,cn=0;
	*zwStr=0;
	while(pStr[i])
	{ 	if(pStr[i]!=c)
	   { 	zwStr[cn]=pStr[i];
			cn++;
		}
		i++;
	}
	zwStr[cn]=0;
	strcpy(pStr,zwStr);
}


void Date(char *Datum)
{	time_t Sekunden_t, *pSekunden_t;
	pSekunden_t=&Sekunden_t;
   struct tm Zeit_tm,*pZeit_tm;
   pZeit_tm=&Zeit_tm;
	time(pSekunden_t);  // ermitteln die Sekunden die seit dem 1.1.1970 vergangen sind.
   pZeit_tm=localtime(pSekunden_t);
	strftime(Datum,80,"%d.%m.%Y",pZeit_tm);
}


void Time(char *Zeit)
{	time_t Sekunden_t, *pSekunden_t;
	pSekunden_t=&Sekunden_t;
   struct tm Zeit_tm,*pZeit_tm;
   pZeit_tm=&Zeit_tm;
	time(pSekunden_t);  // ermitteln die Sekunden die seit dem 1.1.1970 vergangen sind.
   pZeit_tm=localtime(pSekunden_t);
	strftime(Zeit,80,"%X",pZeit_tm);
}


char* StringZerlegen(char * &pMerker,char *pString,char TrennZeichen)
{	char *pAnfang,*pEnde;
 	if(pMerker==NULL)
		pAnfang=pEnde=pString;
	else 
		pAnfang=pEnde=pMerker;
	
	while(*pEnde)
	{	if(*pEnde==TrennZeichen) 
		{	if(*(pEnde+1)!=TrennZeichen)
				break;
		}
		pEnde++;
	}
	
	if(*pEnde==0)
	{	pMerker=pEnde;
		return 0;
	}
	else
	{ *pEnde=0;
		pEnde++;
		pMerker=pEnde;
		return pAnfang;
	}		
}//ENDE char* StringZerlegen(char *pMerker,char *pString,char TrennZeichen)


bool IntegerZahl(char *pStr, int Minzahl, int Maxzahl, int &RueckgabeWert)
{	char *Rest;
	int len;
	Rest=pStr;
	RueckgabeWert=strtol(pStr,&Rest,10);
	len=strlen(Rest);
	if(len==0 && RueckgabeWert>=Minzahl && RueckgabeWert<=Maxzahl)
	{	return true;
	}
	else
	{	RueckgabeWert=0;
		return false;		
	}
}// ENDE bool IntegerZahl(char *pStr,int MinZahl int Maxzahl,&RueckgabeWert)

void Trim(const char *Str)
{  char *pChar;
   int l_LeerZ;
   pChar=(char*)Str;

   l_LeerZ=strspn(pChar,"\t\x20");
   if(l_LeerZ>0)
   { strcpy((char*)Str,(pChar+l_LeerZ));
   }

   pChar=strchr(Str,0)-1;  // Ende String
   pChar=strpbrk(pChar,"\t\x20");
   while(pChar)
   {   *pChar=0;
        pChar--;
        pChar=strpbrk(pChar,"\t\x20");
   }

}

int CountChar(const char *pStr,const char Zeichen)
{  int n=0;
   pStr=strchr(pStr,Zeichen);
   while(pStr)
   { n++;
      pStr++;
      pStr=strchr(pStr,Zeichen);
   }
   return n;
}

bool ZahlOk(const char *ZahlStr,const char *ErlaubeteZeichenStr)
{ int  StrLen,ZeichLen;
  char *pinPK,*pPK,*pEndeStr;
  int  AnzahlP,AnzahlK;;
  Trim(ZahlStr);                               //Leerzeichen entfernen
  StrLen=strlen(ZahlStr);                      //String l�ge ermitteln
  ZeichLen=strspn(ZahlStr,ErlaubeteZeichenStr);//Anzahl der erlaubten Zeichen
  if(StrLen==ZeichLen)
  { pinPK=strpbrk(ErlaubeteZeichenStr,".,");
    if(pinPK)
    { AnzahlP=CountChar(ZahlStr,'.');
      AnzahlK=CountChar(ZahlStr,',');
      if((AnzahlP+AnzahlK)==1)
      {  pEndeStr=strchr(ZahlStr,0)-1;
         pPK=strchr(ZahlStr,*pinPK);
         return (ZahlStr<pPK && pEndeStr>pPK);
      }
      return false;
    }
    return true;
  }
  else return false;
}//ENDE ZahlOk


bool WerteBereich_PK(char *Wert, int Min, int Max,char TZ, int Min2, int Max2 )
{ int StrLen,IntWert;
  char zwWert[80],*pTrennZeichen;
  pTrennZeichen=strchr(Wert,TZ);
  if(pTrennZeichen)
  { StrLen=pTrennZeichen-Wert;
    strncpy(zwWert,Wert,StrLen); zwWert[StrLen]=0;
    IntWert=atoi(Wert);
    if(IntWert<Min || IntWert>Max) return false;
    StrLen=strlen(Wert);
    strcpy(zwWert,pTrennZeichen+1);
    IntWert=atoi(zwWert);
    if(IntWert<Min2 || IntWert>Max2) return false;
  }
  else  return false;

   return true;
} //ENDE  WerteBereichMitPunkt

bool WerteBereich(char *Wert, int Min, int Max, int basis)
{ int  FehlerLen=0;
  char *pFehler,Fehler[20];
  long Zahl;
  pFehler=Fehler;
  Zahl=strtol(Wert,&pFehler,basis);
  FehlerLen=strlen(pFehler);
  if(Zahl>=Min && Zahl<=Max  && FehlerLen==0)
      return true;
  else
      return false;
} //ENDE  WerteBereich
