#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <qdatetime.h>	
#include "konstanten.h"
#include "cpu_sps.h"
#include <math.h>
extern unsigned char *SPS_PortEByte,*SPS_PortAByte;
extern double miliSekunden_double;

	char Befehle[BEREICH_BE_TY][LAENGE_STR];
	char Typen [BEREICH_BE_TY][LAENGE_STR];
	int  BefehlAnzahlParameter[1025];
	
	StructBefehle *BefehleStack=new StructBefehle[PROZESS_DATEN];
	StructProzess *CopyProzessStack=new StructProzess[PROZESS_DATEN];
	StructProzess *ProzessStack=new StructProzess[PROZESS_DATEN];
	int ProzessPointer=0;
			
	StruturCode *BCode=new StruturCode[BODE_ANZAHL];
	StruturCode *Code;
	StruturCode StCode;
	StruturCode *OB_Zeiger[256],*PB_Zeiger[256],*FB_Zeiger[256],*SB_Zeiger[256];
		
	int Status_BausteinName,Status_BausteinNr,Status_Netzwerk_Nr;
	bool StatusAnzeigen=false;
	Baustein_Infos	*OB_Infos=new Baustein_Infos[AnzahlBausteine];
   Baustein_Infos	*PB_Infos=new Baustein_Infos[AnzahlBausteine];
   Baustein_Infos *FB_Infos=new Baustein_Infos[AnzahlBausteine];
   Baustein_Infos *SB_Infos=new Baustein_Infos[AnzahlBausteine];

void strCopy(const char *CStr,const char *UeStr)
{  memset((char*)CStr,0,sizeof(char)*LAENGE_STR);
	strcpy((char*)CStr,(char*)UeStr);
}		

CPU_sps::CPU_sps()
{  char Str[81];
   int n;
	AG_Neustart();
	/* Befehle */
	for(n=0;n<BEREICH_BE_TY;n++) // Initialisieren
	{ sprintf(Str,"%03d = Kein Befehl\n",n);
	  strCopy(Befehle[n],Str);
	  BefehlAnzahlParameter[n]=0;
	}
	
	
	strCopy(Befehle[AND],"U");  				BefehlAnzahlParameter[AND]=3;
	strCopy(Befehle[AND_NOT],"UN");			BefehlAnzahlParameter[AND_NOT]=3;
	strCopy(Befehle[OR],"O");					BefehlAnzahlParameter[OR]=3;
	strCopy(Befehle[OR_NOT],"ON");				BefehlAnzahlParameter[OR_NOT]=3;
	strCopy(Befehle[AND_KL_AUF],"U(");		BefehlAnzahlParameter[AND_KL_AUF]=1;
	strCopy(Befehle[OR_KL_AUF],"O(");			BefehlAnzahlParameter[OR_KL_AUF]=1;
	strCopy(Befehle[KL_ZU],")");				BefehlAnzahlParameter[KL_ZU]=1;
	strCopy(Befehle[IST],"=");					BefehlAnzahlParameter[IST]=3;
	strCopy(Befehle[SET],"S");					BefehlAnzahlParameter[SET]=3;
	strCopy(Befehle[RESET],"R");				BefehlAnzahlParameter[RESET]=3;
	strCopy(Befehle[LOAD],"L");					BefehlAnzahlParameter[LOAD]=3;
	strCopy(Befehle[LC],"LC");					BefehlAnzahlParameter[LC]=3;
	strCopy(Befehle[TRANSVER],"T");			BefehlAnzahlParameter[TRANSVER]=3;
	strCopy(Befehle[SE_TIMER],"SE");			BefehlAnzahlParameter[SE_TIMER]=3;
	strCopy(Befehle[SV_TIMER],"SV");			BefehlAnzahlParameter[SV_TIMER]=3;
	strCopy(Befehle[SI_TIMER],"SI");			BefehlAnzahlParameter[SI_TIMER]=3;
	strCopy(Befehle[SA_TIMER],"SA");			BefehlAnzahlParameter[SA_TIMER]=3;
	strCopy(Befehle[SS_TIMER],"SS");			BefehlAnzahlParameter[SS_TIMER]=3;
  	strCopy(Befehle[ZV],"ZV");					BefehlAnzahlParameter[ZV]=3;
 	strCopy(Befehle[ZR],"ZR");					BefehlAnzahlParameter[ZR]=3;
  	strCopy(Befehle[OR_BLOCK],"O");			BefehlAnzahlParameter[OR_BLOCK]=1;
 	strCopy(Befehle[SPA],"SPA");				BefehlAnzahlParameter[SPA]=3;
	strCopy(Befehle[SPB],"SPB");				BefehlAnzahlParameter[SPB]=3;
	strCopy(Befehle[NE],"NE");					BefehlAnzahlParameter[NE]=2;
	strCopy(Befehle[PLUS_F],"+F");				BefehlAnzahlParameter[PLUS_F]=1;
	strCopy(Befehle[MINUS_F],"-F");			BefehlAnzahlParameter[MINUS_F]=1;
	strCopy(Befehle[MUL_F],"*F");				BefehlAnzahlParameter[MUL_F]=1;
	strCopy(Befehle[DIV_F],"/F");				BefehlAnzahlParameter[DIV_F]=1;
	strCopy(Befehle[GLEICH],"!=F");			BefehlAnzahlParameter[GLEICH]=1;
	strCopy(Befehle[UNGLEICH],"><F");			BefehlAnzahlParameter[UNGLEICH]=1;
	strCopy(Befehle[GROESSER],">F");			BefehlAnzahlParameter[GROESSER]=1;
	strCopy(Befehle[GROESSER_GLEICH],">=F");BefehlAnzahlParameter[GROESSER_GLEICH]=1;
	strCopy(Befehle[KLEINER],"<F");			BefehlAnzahlParameter[KLEINER]=1;
	strCopy(Befehle[KLEINER_GLEICH],"<=F");	BefehlAnzahlParameter[KLEINER_GLEICH]=1;
	strCopy(Befehle[STS],"STS");				BefehlAnzahlParameter[STS]=1;
	strCopy(Befehle[STP],"STP");				BefehlAnzahlParameter[STP]=1;
	strCopy(Befehle[BEA],"BEA");				BefehlAnzahlParameter[BEA]=1;
	strCopy(Befehle[BEB],"BEB");				BefehlAnzahlParameter[BEB]=1;
	strCopy(Befehle[BE],"BE");					BefehlAnzahlParameter[BE]=1;
	strCopy(Befehle[NOP0],"NOP0");				BefehlAnzahlParameter[NOP0]=1;
	strCopy(Befehle[NOP1],"NOP1");				BefehlAnzahlParameter[NOP1]=1;
	strCopy(Befehle[TAK],"TAK");				BefehlAnzahlParameter[TAK]=1;
	strCopy(Befehle[UW],"UW");					BefehlAnzahlParameter[UW]=1;
	strCopy(Befehle[OW],"OW");					BefehlAnzahlParameter[OW]=1;
	strCopy(Befehle[XOW],"XOW");				BefehlAnzahlParameter[XOW]=1;
	strCopy(Befehle[SLW],"SLW");				BefehlAnzahlParameter[SLW]=1;
	strCopy(Befehle[SRW],"SRW");				BefehlAnzahlParameter[SRW]=1;
	strCopy(Befehle[KEW],"KEW");				BefehlAnzahlParameter[KEW]=1;
	strCopy(Befehle[SRW],"KZW");				BefehlAnzahlParameter[KZW]=1;
	strCopy(Befehle[ADD],"ADD");				BefehlAnzahlParameter[ADD]=3;
	strCopy(Befehle[DUF],"DUF");				BefehlAnzahlParameter[DUF]=1;
	strCopy(Befehle[DEF],"DEF");				BefehlAnzahlParameter[DEF]=1;
	strCopy(Befehle[INC],"I");					BefehlAnzahlParameter[INC]=1;
	strCopy(Befehle[DEC],"D");					BefehlAnzahlParameter[DEC]=1;
	strCopy(Befehle[IST_SP_MARKE],"IST_SP_MARKE"); BefehlAnzahlParameter[IST_SP_MARKE]=1;
   /*Typen*/
   for(n=0;n<BEREICH_BE_TY;n++) // Initialisieren
	{ sprintf(Str,"%d = Kein Type\n",n);
	  strCopy(Typen[n],Str);
	}
	strCopy(Typen[EINGANG],"E");
   strCopy(Typen[AUSGANG],"A");
	strCopy(Typen[MERKER],"M");
	strCopy(Typen[E_BYTE],"EB");
	strCopy(Typen[A_BYTE],"AB");
	strCopy(Typen[M_BYTE],"MB");
	strCopy(Typen[D_BYTE],"DB");
	strCopy(Typen[D_RECHTS],"DR");
	strCopy(Typen[D_LINKS],"DL");
	strCopy(Typen[E_WORD],"EW");
	strCopy(Typen[A_WORD],"AW");
	strCopy(Typen[M_WORD],"MW");
	strCopy(Typen[D_WORD],"DW");
	strCopy(Typen[TIMER],"T");
	strCopy(Typen[ZAEHLER],"Z");
	strCopy(Typen[K_TIMER],"KT");
	strCopy(Typen[K_ZAEHLER],"KZ");
	strCopy(Typen[K_B_ZAHL],"KB");
	strCopy(Typen[K_F_ZAHL],"KF");
	strCopy(Typen[K_H_ZAHL],"KH");
	strCopy(Typen[K_M_ZAHL],"KM");
	strCopy(Typen[K_Y_ZAHL],"KY");
	strCopy(Typen[B_F_ZAHL],"BF");
   strCopy(Typen[GLEICH_MARKE],"=");
	strCopy(Typen[OB],"OB");
	strCopy(Typen[PB],"PB");
	strCopy(Typen[FB],"FB");
	strCopy(Typen[SB],"SB");
   strCopy(Typen[ZUR_SP_MARKE],"ZUR_SP_MARKE");
 };//ENDE CPU_sps::CPU_sps(void)

void CPU_sps::AG_Neustart()
{ 	Alu=0;Bit_Register=0;
  	Akku1=0;Akku2=0;
	returnWertInterpreter=0;
// Stacks
 	memset(WStack,0,1000*sizeof(unsigned int));
  	memset(OStack,0,1000);
	StackPointer=0;
// Bytes	
	memset(EByte,0,sizeof(char)*256);
	memset(AByte,0,sizeof(char)*256);	
	memset(MByte,0,sizeof(char)*256);	
	memset(ZByte,0,sizeof(char)*256);
	memset(TByte,0,sizeof(char)*256);	
//  Zaehler   
	memset(Z_KZ,0,sizeof(short)*256);	
	memset(Z_Stand,0,sizeof(short)*256);		
	memset(ZV_Flanke,0,sizeof(short)*256);		
	memset(ZR_Flanke,0,sizeof(short)*256);		
	memset(MZaehlerFlanke_LH,0,sizeof(short)*256);
// Timer	
	memset(T_KT,0,sizeof(short)*256);	
	memset( T_Input,0,sizeof(short)*256);	
	memset(TLaufZeit,0,sizeof(short)*256);	
	memset(Zeitraster,0,sizeof(short)*256);		
	memset(Reset_Timer,0,sizeof(short)*256);		
	memset(T_sperren,0,sizeof(short)*256);
	memset(MTimerFlanke_LH,0,sizeof(short)*256);
   memset(MTimerFlanke_HL,0,sizeof(short)*256);

}//ENDE AG_Neustart()
 

int CPU_sps::SPS_Interpreter(int BausteinName,int BausteinNr)
{ int Op=0,n;
   short wert=0;
	int  pC,pC_Merker;
 	int RBName,RBNr;
   StruturCode *PCode=NULL;
	int Befehl_vom_Stack=0;
   int NetzwerkNr=1;
	Alu=0,Bit_Register=0,AluLaden=true;;
	bool Sprung=false;
   bool Anzeige=false;
   int Befehl=0,Operand=0,ZahlenWert=0,Alu=0;
   short zwWert;
	bool jaRetrun=false;
	if(BausteinName==OB)
  	{	if(OB_Infos[BausteinNr].vorhanden)
		{	PCode=OB_Zeiger[BausteinNr];
		}
		else
		{ printf("OB%d nicht vorhanden!\n",BausteinNr);
		  return -1;
		}
	}
	else if(BausteinName==PB)
	{	if(PB_Infos[BausteinNr].vorhanden)
		{	PCode=PB_Zeiger[BausteinNr];
		}
		else
		{ printf("PB%d nicht vorhanden!\n",BausteinNr);
		  return -1;
		}
	}
	else if(BausteinName==FB)
	{	if(FB_Infos[BausteinNr].vorhanden)
		{	PCode=FB_Zeiger[BausteinNr];
		}
		else
		{ printf("FB%d nicht vorhanden!\n",BausteinNr);
		  return -1;
		}
	}
	else if(BausteinName==SB)
	{	if(SB_Infos[BausteinNr].vorhanden)
		{	PCode=SB_Zeiger[BausteinNr];
		}
		else
		{ printf("SB%d nicht vorhanden!\n",BausteinNr);
		  return -1;
		}
	}
	pC=1;
	while(pC<=PCode[0].Code)
	{  Befehl=Operand=ZahlenWert=Inhalt=0;
		switch(BefehlAnzahlParameter[PCode[pC].Code])
		{  case 1:
					Befehl=PCode[pC++].Code;
			break;
			case 2:
					Befehl=PCode[pC++].Code;
					Operand=PCode[pC++].Code;
			break;
			case 3:
					Befehl=PCode[pC++].Code;
					Operand=PCode[pC++].Code;
            	ZahlenWert=PCode[pC++].Code;
			break;
			default:
				exit(-1);
		}//ENDE switch(BefehlAnzahlParameter[BCode[pC]->Code])

		switch(Befehl) // Akku Laden
		{	case AND:
			case OR:
			case AND_NOT:
			case OR_NOT:
			if(AluLaden==true)
			{		Inhalt=getBit(Operand,ZahlenWert);
					if(Befehl==AND_NOT || Befehl==OR_NOT)
							Alu=!Inhalt;
					else
							Alu=Inhalt;
					AluLaden=false;
					goto MarkeProzessStack;
			}
			else
			{		Inhalt=getBit(Operand,ZahlenWert);
					Bit_Register=Inhalt;
			}
			break;
		}//ENDE switch(Befehl)

// Befehle Ausfhren
 		switch(Befehl)
		{	case NOP0:
			case NOP1:
	    		//Ein bischen Urlaub!
			break;
			case NE:
				AluLaden=true;
				NetzwerkNr=Operand;
   			Anzeige=Status_BausteinName==BausteinName && Status_BausteinNr==BausteinNr &&
							Status_Netzwerk_Nr==NetzwerkNr;
				if(Anzeige)
				{	ProzessPointer=0;
					memset(ProzessStack,0,sizeof(ProzessStack)*(PROZESS_DATEN+10));//**************************
               StatusAnzeigen=true;
				}
				continue;
			break;
			case AND:
				Alu=Alu && Bit_Register;
			break;
			case OR:
				Alu=Alu || Bit_Register;
			break;
			case AND_NOT:
				Alu=Alu && (!Bit_Register);
			break;
			case OR_NOT:
				Alu=Alu || (!Bit_Register);
			break;
			case OR_BLOCK:
				popStack(OR_BLOCK,Alu);
				AluLaden=true;
			break;
			case AND_KL_AUF:
				if(AluLaden)
				{	Alu=1;  
					popStack(AND_KL_AUF,Alu);
				}
				else
					popStack(AND_KL_AUF,Alu);
				AluLaden=true;
			break;
			case OR_KL_AUF:
				popStack(OR_KL_AUF,Alu);
				AluLaden=true;
			break;
			case KL_ZU:
				pushStack(Befehl_vom_Stack,Bit_Register);
				if (Befehl_vom_Stack==AND_KL_AUF)
					 Alu=Alu && Bit_Register;
				else if(Befehl_vom_Stack==OR_KL_AUF)
					 Alu=Alu || Bit_Register;
			break;
			case IST:
				while(pushStack(Op,wert))
				{	if (Op==OR_BLOCK)
						Alu=Alu || wert;
				}
        		SetBit(Operand,ZahlenWert,Alu);
				Inhalt=getBit(Operand,ZahlenWert);
				AluLaden=true;
			break;
			case SET:
				if(Operand==ZAEHLER)
				{	if(Zaehler_SET_Impulse_LowToHighFlanke(ZahlenWert,Alu))
						 Z_Stand[ZahlenWert]=KZ_BcdToDez(Akku1);
					if(Z_Stand[ZahlenWert]>0)
						SetBit(Operand,ZahlenWert,1);
					else
						SetBit(Operand,ZahlenWert,0);
				}
				else
				{	while(pushStack(Op,wert))
					{	if (Op==OR_BLOCK)
							Alu=Alu || wert;
					}
					if(Alu)
					{  SetBit(Operand,ZahlenWert,1);
						//**********Inhalt=getBit(Operand,ZahlenWert);
					}
				}
				Inhalt=getBit(Operand,ZahlenWert);
				AluLaden=true;
			break;
			case RESET:
				if(Operand==ZAEHLER)
				{	if(Alu) Z_Stand[ZahlenWert]=0;
					if(Z_Stand[ZahlenWert]>0)
      				 SetBit(Operand,ZahlenWert,1);
					else
						 SetBit(Operand,ZahlenWert,0);
				}
				else
				{	while(pushStack(Op,wert))
					{	if (Op==OR_BLOCK)
						Alu=Alu || wert;
					}
					if(Alu)
					{ 	SetBit(Operand,ZahlenWert,0);
						//**** Inhalt=getBit(Operand,ZahlenWert);
					}
					if(Operand==TIMER)
			  		Function_Reset_Timer(ZahlenWert,Alu);
				}
				Inhalt=getBit(Operand,ZahlenWert);
				AluLaden=true;
			break;
			case ZV:
				Zaehler_ZV(ZahlenWert,Alu);
				AluLaden=true;
			break;
			case ZR:
				Zaehler_ZR(ZahlenWert,Alu);
				AluLaden=true;
			break;
			case SE_TIMER:
				SE_Timer(ZahlenWert,Akku1,Alu);
				AluLaden=true;
			break;
			case SI_TIMER:
			  SI_Timer(ZahlenWert,Akku1,Alu);
				AluLaden=true;
			case SV_TIMER:
 				SV_Timer(ZahlenWert,Akku1,Alu);
				AluLaden=true;
			break;
			case SS_TIMER:
 				SS_Timer(ZahlenWert,Akku1,Alu);
				AluLaden=true;
			break;
			case SA_TIMER:
 				SA_Timer(ZahlenWert,Akku1,Alu);
				AluLaden=true;
			break;
			case PLUS_F:
				Akku1=Akku2+Akku1;
			break;
			case MINUS_F:
				Akku1=Akku2-Akku1;
			break;
			case MUL_F:
				Akku1=Akku2*Akku1;
			break;
			case DIV_F:
				if(Akku1!=0)
				{	Akku1=Akku2 / Akku1;
					Akku2=Akku2 % Akku1;
				}
				else
					SetBit(MERKER,2047,1);//M255.7 Division durch Null
			break;
			case GLEICH:
				Alu=Akku2==Akku1;
				AluLaden=false;
			break;
			case UNGLEICH:
				Alu=Akku2 != Akku1;
				AluLaden=false;
			break;
			case GROESSER:
				Alu=Akku2>Akku1;
				AluLaden=false;
			break;
			case GROESSER_GLEICH:
				Alu=Akku2>=Akku1;
				AluLaden=false;
			break;
			case KLEINER:
				Alu=Akku2<Akku1;
				AluLaden=false;
			break;
			case KLEINER_GLEICH:
				Alu=Akku2<=Akku1;
				AluLaden=false;
			break;
			case TAK:
				zwSpeicher=Akku1;
				Akku1=Akku2;
				Akku2=zwSpeicher;
			break;
			case UW:
				Akku1=Akku2 & Akku1;
			break;
			case OW:
				Akku1=Akku2 | Akku1;
			break;
			case XOW:
				Akku1=Akku2 ^ Akku1;
			break;
			case SLW:
				Akku1<<=1;
			break;
			case SRW:
				Akku1>>=1;
			break;
			case	KEW:
				Akku1=~Akku1;
			break;
			case 	KZW:
				Akku1=(~Akku1)+1;
			break;
			case ADD:
             Akku1+=ZahlenWert;
			break;
			case INC:
				zwWert=Akku1 & 0x00FF;
				zwWert++;
				zwWert&=0x00FF;
				Akku1&=0xFF00;
				Akku1|=zwWert;
			break;
			case DEC:
				zwWert=Akku1 & 0x00FF;
				zwWert--;
				zwWert&=0x00FF;
				Akku1&=0xFF00;
				Akku1|=zwWert;
			break;
			case DUF:
				Akku1=DezToBcd(Akku1);
			break;
			case DEF:
				Akku1=BcdToDez(Akku1);
			break;
			case STS:
			case STP:
				AG_Stop=true;
				return 0;
			break;
			case LOAD:
				Akku2=Akku1;
				switch(Operand)
				{	case E_BYTE:
						Akku1=EByte[ZahlenWert];
					break;
					case A_BYTE:
						Akku1=AByte[ZahlenWert];
					break;
					case M_BYTE:
						Akku1=MByte[ZahlenWert];
					break;
					case E_WORD:
						Akku1=(EByte[ZahlenWert]<<8) |  EByte[ZahlenWert+1];
					break;
					case A_WORD:
						Akku1=(AByte[ZahlenWert]<<8) |  AByte[ZahlenWert+1];
					break;
					case M_WORD:
						Akku1=(MByte[ZahlenWert]<<8) |  MByte[ZahlenWert+1];
					break;
					case D_BYTE:
						/*******************/
					break;
					case D_RECHTS:
						/*******************/
					break;
					case D_LINKS:
						/******************/
					break;
					case K_ZAEHLER:
						Akku1=ZahlenWert;
					break;
					case ZAEHLER:
						Akku1=Z_Stand[ZahlenWert];
					break;
					case K_TIMER:
						Akku1=ZahlenWert;
					break;
					case TIMER:
						Akku1=TLaufZeit[ZahlenWert];
					break;
					case K_B_ZAHL:
					case K_F_ZAHL:
					case K_H_ZAHL:
					case K_M_ZAHL:
					case K_Y_ZAHL:
						Akku1=ZahlenWert;
					break;
				}//ENDE switch(Operand)
			break; //ENDE LOAD
			case LC:
				Akku2=Akku1;
				switch(Operand)
				{ 	case TIMER:
						Akku1=DezToBcd(TLaufZeit[ZahlenWert]);
					break;
					case  ZAEHLER:
						Akku1=DezToBcd(Z_Stand[ZahlenWert]);
					break;
				}
			break;
			case TRANSVER:
				switch(Operand)
				{	case E_BYTE:
						EByte[ZahlenWert]=Akku1;
					break;
					case A_BYTE:
						AByte[ZahlenWert]=Akku1;
					break;
					case M_BYTE:
						MByte[ZahlenWert]=Akku1;
					break;
					case E_WORD:
						EByte[ZahlenWert+1]=Akku1;
						EByte[ZahlenWert]=Akku1 >> 8;
					break;
					case A_WORD:
						AByte[ZahlenWert+1]=Akku1;
						AByte[ZahlenWert]=Akku1 >> 8;
					break;
					case M_WORD:
						MByte[ZahlenWert+1]=Akku1;
						MByte[ZahlenWert]=Akku1 >> 8;
					break;
					case D_BYTE:
						/*******************/
					break;
					case D_RECHTS:
						/*******************/
					break;
					case D_LINKS:
						/******************/
					break;
				}//ENDE switch(Opernad)
			break;
			case SPA:
					switch(Operand)
					{	case OB:
						case PB:
						case FB:
						case SB:
							RBName=Operand;
							RBNr=ZahlenWert;
							returnWertInterpreter=SPS_Interpreter(RBName,RBNr); /*BausteinName,BausteinNr;*/
							AluLaden=true;
						break;
						case GLEICH_MARKE:
							if(ZahlenWert>0)
							{ 	pC_Merker=ZahlenWert; //Adresse;
								if(pC_Merker>=pC)
								{	for(n=pC;n<=pC_Merker;n+=BefehlAnzahlParameter[PCode[n].Code])
									{	if(Anzeige)
										{	if(n==pC)
											{	ProzessStack[ProzessPointer].Bearbeitet=true;
												ProzessStack[ProzessPointer].Vek=Alu;
												ProzessStack[ProzessPointer].Inhalt=Inhalt;
												ProzessStack[ProzessPointer].Akku1=Akku1;
												ProzessStack[ProzessPointer].Akku2=Akku2;
												ProzessPointer++;
											}	else
											{	ProzessStack[ProzessPointer].Bearbeitet=false;
												ProzessStack[ProzessPointer].Vek=0;
												ProzessStack[ProzessPointer].Inhalt=0;
												ProzessStack[ProzessPointer].Akku1=0;
												ProzessStack[ProzessPointer].Akku2=0;;
												ProzessPointer++;
											}
										}
									}//ENDE for(n=pC;n<=pC_Merker;n+=BefehlAnzahlParameter[PCode[n].Code])
									pC=pC_Merker;
									Sprung=true;
									continue;
								} else //if(pC_Merker<pC)
								{  printf("\n\n*** Unendlich Schleife ***\a\n\n");
										exit(-1);
								}//ENDE if(pC_Merker>pC)
       					}//ENDE if(ZahlenWert==ZUR_SP_MARKE)
						break;
					}//ENDE switch(Opernad)
			break;
			case SPB:
				switch(Operand)
				{	case OB:
					case PB:
					case FB:
					case SB:
						RBName=Operand;
						RBNr=ZahlenWert;
						if(Alu) returnWertInterpreter=SPS_Interpreter(RBName,RBNr); /*BausteinName,BausteinNr;*/
						AluLaden=true;
					break;
					case GLEICH_MARKE:
						if(ZahlenWert>0)
						{  AluLaden=true;
							if(Alu)
							{	pC_Merker=ZahlenWert;//Adresse;
								if(pC_Merker>=pC)
								{	for(n=pC;n<=pC_Merker;n+=BefehlAnzahlParameter[PCode[n].Code])
									{	if(Anzeige)
										{	if(n==pC)
											{	ProzessStack[ProzessPointer].Bearbeitet=true;
												ProzessStack[ProzessPointer].Vek=Alu;
												ProzessStack[ProzessPointer].Inhalt=Inhalt;
												ProzessStack[ProzessPointer].Akku1=Akku1;
												ProzessStack[ProzessPointer].Akku2=Akku2;
												ProzessPointer++;
											}	else
											{	ProzessStack[ProzessPointer].Bearbeitet=false;
												ProzessStack[ProzessPointer].Vek=0;
												ProzessStack[ProzessPointer].Inhalt=0;
												ProzessStack[ProzessPointer].Akku1=0;
												ProzessStack[ProzessPointer].Akku2=0;;
												ProzessPointer++;
											}
										}
									}//ENDE for(n=pC;n<=pC_Merker;n+=BefehlAnzahlParameter[PCode[n].Code])
									pC=pC_Merker;
									Sprung=true;
									continue;
								} else //if(pC_Merker<pC)
								{  printf("\n\n*** Unendlich Schleife ***\a\n\n");
										exit(-1);
								}//ENDE if(pC_Merker>pC)
							}//ENDE if(Alu)
						} //ENDE if(ZahlenWert==ZUR_SP_MARKE)
					break;
					}//ENDE switch(Operand)
			break;
			case IST_SP_MARKE:
				// Mach me Pause
			break;


			case BE:
				return 0;
			break;
			case BEA:
				jaRetrun=true;
			break;
			case BEB:
				if(Alu) jaRetrun=true;
			break;
		}//END switch(Befehl)
MarkeProzessStack:
		if(Anzeige)
		{	ProzessStack[ProzessPointer].Bearbeitet=true;
			ProzessStack[ProzessPointer].Vek=Alu;
			ProzessStack[ProzessPointer].Inhalt=Inhalt;
			ProzessStack[ProzessPointer].Akku1=Akku1;
			ProzessStack[ProzessPointer].Akku2=Akku2;
			ProzessPointer++;
		}
		if (jaRetrun) return 0;
	} //END while(pC<PCode[0])
return 0;
} //END void CPU_sps::Interpreter()

short CPU_sps::Load(short Operand,short Nr)
{	short Wert;
	switch(Operand)
	{  case E_BYTE:
			Wert=EByte[Nr];
		break;
		case A_BYTE:
			Wert=AByte[Nr];
		break;
		case M_BYTE:
			Wert=MByte[Nr];
		break;
		case E_WORD:
         Wert=(EByte[Nr]<<8) + EByte[Nr+1];
		break;
		case A_WORD:
			 Wert=(AByte[Nr]<<8) + AByte[Nr+1];
		break;
		case M_WORD:
			 Wert=(MByte[Nr]<<8) + MByte[Nr+1];
		break;
		default:
			Wert=0;
	}
	return Wert;
}//ENDE CPU_sps::Load(short Operand,short Nr)

 unsigned int CPU_sps::getBit(unsigned int Operand,unsigned int BitNr)
{	unsigned char MerkeByte;
	switch(Operand)
	{  case EINGANG:
			MerkeByte=EByte[BitNr/8];
		break;
		case AUSGANG:
			MerkeByte=AByte[BitNr/8];
		break;
		case MERKER:
			MerkeByte=MByte[BitNr/8];
		break;
		case	ZAEHLER:
			MerkeByte=ZByte[BitNr/8] ;
		break;
		case TIMER:
			MerkeByte=TByte[BitNr/8];
		break;
		default:
			exit(-1);
	}
	 return (MerkeByte & (1 << (BitNr % 8)))!=0;
} //ENDE unsigned int getBit

void CPU_sps::SetBit(unsigned int Operand,unsigned int BitNr,unsigned int Signal)
{	unsigned char *AdresseByte;
   switch(Operand)
	{  case EINGANG:
			AdresseByte=&EByte[BitNr/8];
		break;
		case AUSGANG:
			AdresseByte=&AByte[BitNr/8];
		break;
		case MERKER:
			AdresseByte=&MByte[BitNr/8];
		break;
		case	ZAEHLER:
			AdresseByte=&ZByte[BitNr/8] ;
		break;
		case TIMER:
			AdresseByte=&TByte[BitNr/8];
		break;
		default:
			AdresseByte=NULL;
			exit(-1);
	}//ENDE switch(Operand)
	if (AdresseByte!=NULL)
	{	if (Signal) // SetBit
			 *AdresseByte|=(1 << (BitNr % 8));
		else //  Reset Bit
			*AdresseByte&= ~(1 << (BitNr % 8));
	}
}//ENDE SetBit


short CPU_sps::HexToDez(char *Hexzahl)
{  short Zahl=0,Ziffer=0;
	int  Faktor=1,i;
   i=strlen(Hexzahl)-1;
	while(i>=0)
   { 	if(Hexzahl[i]>=65)
      	Ziffer=(short)(Hexzahl[i]-55);
     	else
			Ziffer=(short)(Hexzahl[i]-48);
   	Zahl+=Ziffer*Faktor;
		Faktor*=16;
		i--;
	}
 	return Zahl;
}//ENDE  HexToDez()

void CPU_sps::DezToHex(short Dez,char *Hexzahl)
{	int i;
	short zwZahl;
	for(i=3;i>=0;i--)
	{ zwZahl=(Dez & 0x000F);
     if(zwZahl<10)
		Hexzahl[i]=(char)(zwZahl+48);
	  else
		Hexzahl[i]=(char)(zwZahl+55);
		Dez>>=4;
	}
	Hexzahl[4]=0;
} //ENDE DezToHex()

short CPU_sps::BinToDez(char *Binzahl)
{  short Zahl=0,Ziffer=0;
   int Faktor=2,i;
   i=strlen(Binzahl)-1;
	Zahl=(short)(Binzahl[i]-48);
	while(i)
   {	i--;
		if(Binzahl[i]!=' ')
		{	Ziffer=(short)(Binzahl[i]-48);
   		Zahl+=Ziffer*Faktor;
			Faktor*=2;
		}
	}
 	return Zahl;
}//ENDE  BinToDez()

void CPU_sps::DezToBin(short Dez,char *ZahlenStr)
{  int i;
  	for(i=16;i>=0;i--)
   { 	ZahlenStr[i]=(char)(Dez & 0x0001)+48;
		if(i==9) ZahlenStr[--i]=' ';
		Dez>>=1;
	}
	ZahlenStr[17]=0;
}//ENDE  DezToBin()


short CPU_sps::BcdToDez(short BCD_Zahl)
{ short n,Zahl,faktor=10;
  Zahl = BCD_Zahl & 0x0F;
  for(n=2;n<=4;n++)
  {   BCD_Zahl>>=4; // 4 Bit nach rechts verschieben
		Zahl+=(BCD_Zahl & 0x0F)*faktor;
		faktor*=10;
	}
	return Zahl;
}//ENDE short CPU_sps::BcdToDez(short BCD_Zahl)

short CPU_sps::DezToBcd(short Dezimal)
{ short  BCD_Zahl;
  if(Dezimal>9999 || Dezimal<0) return -1;
	BCD_Zahl=Dezimal/1000;
	Dezimal%=1000;
	BCD_Zahl<<=4;   // 4 Bit nach links verschieben
	BCD_Zahl+=Dezimal/100;
	Dezimal%=100;
	BCD_Zahl<<=4;	// 4 Bit nach links verschieben
	BCD_Zahl+=Dezimal/10;
	Dezimal%=10;
	BCD_Zahl<<=4,	// 4 Bit nach links verschieben
	BCD_Zahl+=Dezimal;
	return BCD_Zahl;
}//ENDE short DezToBcd(short Dezimal)

short CPU_sps::KT_BcdToDez(short BCD_Zahl,short &Zeit_Basis)
{ 	short Zahl;
  	Zahl = BCD_Zahl & 0x0F;
  	BCD_Zahl>>=4; // 4 Bit nach rechts verschieben
  	Zahl+=(BCD_Zahl & 0x0F)*10;
  	BCD_Zahl>>=4; // 4 Bit nach rechts verschieben
  	Zahl+=(BCD_Zahl & 0x0F)*100;
  	BCD_Zahl>>=4; // 4 Bit nach rechts verschieben
 	Zeit_Basis=BCD_Zahl & 0x0F;
	return Zahl;
}//ENDE short KT_BcdToDez(short BCD_Zahl,short &Zeit_Basis)

short CPU_sps::KZ_BcdToDez(short BCD_Zahl)
{	short Zahl;
  	Zahl = BCD_Zahl & 0x0F;
  	BCD_Zahl>>=4; // 4 Bit nach rechts verschieben
  	Zahl+=(BCD_Zahl & 0x0F)*10;
  	BCD_Zahl>>=4; // 4 Bit nach rechts verschieben
  	Zahl+=(BCD_Zahl & 0x0F)*100;
  	return Zahl;
}//ENDE short KZ_BcdToDez(short BCD_Zahl)

short CPU_sps::KyToZahl(char *ky_Zahl)
{  char *pLByte;
	short word;
	pLByte=strchr(ky_Zahl,',');
   *pLByte=0;
   pLByte++;
	word=atoi(ky_Zahl);
	word=(word<<8) & 0xFF00;
	word+=atoi(pLByte);
	return word;
}//ENDE KyToZahl(char *ky_Zahl)

void CPU_sps::ZahlToKy(short Dez,char *ky_Zahl)
{ 	short HB,LB;
   LB=Dez & 0x00FF;
	HB=(Dez >>  8) & 0x00FF;
   sprintf(ky_Zahl,"%03d,%03d",HB,LB);
}//ENDE ZahlToKy(short Dez,char *ky_Zahl)

short CPU_sps::Zaehler_ZV(short Nr, bool Signal)
{ if(Signal==false)
		ZV_Flanke[Nr]=false;
	if(Signal && ZV_Flanke[Nr]==false)
   {	Z_Stand[Nr]++;
		ZV_Flanke[Nr]=true;
	}
	if(Z_Stand[Nr]>0)
 		SetBit(ZAEHLER,Nr,1); //ZBit[Nr]=1;
 	else
		SetBit(ZAEHLER,Nr,0); // ZBit[Nr]=0;
	return Z_Stand[Nr];
}//ENDE Zaehler_ZV(short Nr, bool Signal)


short CPU_sps::Zaehler_ZR(short Nr,bool Signal)
{ if(Signal==false)
		ZR_Flanke[Nr]=false;
	if(Signal && ZR_Flanke[Nr]==false)
	{	if(Z_Stand[Nr]>0)	Z_Stand[Nr]--;
   		ZR_Flanke[Nr]=true;
	}
 	if(Z_Stand[Nr]>0)
 		 SetBit(ZAEHLER,Nr,1); //ZBit[Nr]=1;
 	else
 		 SetBit(ZAEHLER,Nr,0); //ZBit[Nr]=0;
	return Z_Stand[Nr];
}//ENDE Zaehler_ZR(short Nr, bool Signal)

bool CPU_sps::Zaehler_SET_Impulse_LowToHighFlanke(short Nr,bool Signal)
{	 short impuls=false;
	 if(Signal && !MZaehlerFlanke_LH[Nr])
	 {	MZaehlerFlanke_LH[Nr]=true;
	 	  impuls=true;
	 }
	 else if (!Signal)
	 {	MZaehlerFlanke_LH[Nr]=false;
	 }
 return	impuls;
}//ENDE TImpulse_LowToHighFlanke

bool CPU_sps::TImpulse_LowToHighFlanke(short Nr,bool Signal)
{	 bool impuls=false;
	 if(Signal && !MTimerFlanke_LH[Nr])
	 {	MTimerFlanke_LH[Nr]=true;
	 	  impuls=true;
	 }
	 else if (!Signal)
	 {	MTimerFlanke_LH[Nr]=false;
	 }
  return	impuls;
}//ENDE TImpulse_LowToHighFlanke

bool CPU_sps::TImpuls_HighToLowFlanke(short Nr, bool Signal)
{ 	 bool impuls=false;
	 if(Signal && !MTimerFlanke_HL[Nr])
	 {	MTimerFlanke_HL[Nr]=true;
	 	  impuls=false;
	 }
	 else if (!Signal && MTimerFlanke_HL[Nr])
	 {	impuls=true;
	   MTimerFlanke_HL[Nr]=false;
	 }
 return	impuls;
}//ENDE TImpuls_HighToLowFlanke


short CPU_sps::SI_Timer(short Nr,short BCD_Zahl, bool Signal)
{	bool Impuls;
  Impuls=TImpulse_LowToHighFlanke(Nr,Signal);
	if(Reset_Timer[Nr]==true)
	{	TLaufZeit[Nr]=0;
		SetBit(TIMER,Nr,0); //TBit[Nr]=0;
		T_Input[Nr]=false;
		
	}
	else 	if(Impuls && !T_Input[Nr])
	{	TLaufZeit[Nr]=KT_BcdToDez(BCD_Zahl,Zeitraster[Nr]);
		SetBit(TIMER,Nr,0); //TBit[Nr]=0;
		T_Input[Nr]=true;
		msTLaufZeit[Nr]=(double)TLaufZeit[Nr]*ZeitRasterDouble(Zeitraster[Nr]);
		msTimerStart[Nr]=miliSekunden_double;
	}
  else if(!Signal)
	{  TLaufZeit[Nr]=0;
		T_Input[Nr]=false;
	}
	if(TLaufZeit[Nr]>0 && T_Input[Nr]) SetBit(TIMER,Nr,1);//TBit[Nr]=1;
	else if (TLaufZeit[Nr]==0 && T_Input[Nr]) SetBit(TIMER,Nr,0); //TBit[Nr]=0;
	return getBit(TIMER,Nr); // ;TBit[Nr];
}//ENDE SI_Timer


short CPU_sps::SV_Timer(short Nr,short BCD_Zahl, bool Signal)
{ bool Impuls;
  Impuls=TImpulse_LowToHighFlanke(Nr,Signal);
	if(Reset_Timer[Nr]==true)
	{	TLaufZeit[Nr]=0;
		SetBit(TIMER,Nr,0); // TBit[Nr]=0;
		T_Input[Nr]=false;
	}
	else 	if(Impuls)
	{	TLaufZeit[Nr]=KT_BcdToDez(BCD_Zahl,Zeitraster[Nr]);
		T_Input[Nr]=true;
		msTLaufZeit[Nr]=(double)TLaufZeit[Nr]*ZeitRasterDouble(Zeitraster[Nr]);
		msTimerStart[Nr]=miliSekunden_double;	
	}

	if(TLaufZeit[Nr]>0)
		SetBit(TIMER,Nr,1); //TBit[Nr]=1;
	else if (TLaufZeit[Nr]==0)
	{ SetBit(TIMER,Nr,0); //TBit[Nr]=0;
		T_Input[Nr]=false;
	}
	return getBit(TIMER,Nr); //TBit[Nr];
}//ENDE SV_Timer



short CPU_sps::SE_Timer(short Nr,short BCD_Zahl, bool Signal)
{ bool Impuls;
  Impuls=TImpulse_LowToHighFlanke(Nr,Signal);
	if(Reset_Timer[Nr]==true)
	{	TLaufZeit[Nr]=0;
		SetBit(TIMER,Nr,0); //TBit[Nr]=0;
		T_Input[Nr]=false;
	}
	else
	{	if(Impuls && !T_Input[Nr])
		{	TLaufZeit[Nr]=KT_BcdToDez(BCD_Zahl,Zeitraster[Nr]);
			SetBit(TIMER,Nr,0);//TBit[Nr]=0;
   		T_Input[Nr]=true;
			msTLaufZeit[Nr]=(double)TLaufZeit[Nr]*ZeitRasterDouble(Zeitraster[Nr]);
			msTimerStart[Nr]=miliSekunden_double;
		}
 		else if(!Signal)
		{   TLaufZeit[Nr]=0;
 			 T_Input[Nr]=false;
			 SetBit(TIMER,Nr,0); //TBit[Nr]=0;
		}
		if(TLaufZeit[Nr]>0 && T_Input[Nr])SetBit(TIMER,Nr,0); // TBit[Nr]=0;
		else if (TLaufZeit[Nr]==0 && T_Input[Nr]) SetBit(TIMER,Nr,1); //TBit[Nr]=1;
	}
	return getBit(TIMER,Nr); // TBit[Nr];
}//ENDE SE_Timer


short CPU_sps::SS_Timer(short Nr,short BCD_Zahl, bool Signal)
{bool Impuls;
  Impuls=TImpulse_LowToHighFlanke(Nr,Signal);
	if(Reset_Timer[Nr]==true)
	{	TLaufZeit[Nr]=0;
		SetBit(TIMER,Nr,0); //TBit[Nr]=0;
		T_Input[Nr]=false;
	}
	else
	{	if(Impuls)
		{	TLaufZeit[Nr]=KT_BcdToDez(BCD_Zahl,Zeitraster[Nr]);
			T_Input[Nr]=true;
			msTLaufZeit[Nr]=(double)TLaufZeit[Nr]*ZeitRasterDouble(Zeitraster[Nr]);
			msTimerStart[Nr]=miliSekunden_double;
		}
		if (TLaufZeit[Nr]==0 && T_Input[Nr]) SetBit(TIMER,Nr,1); // TBit[Nr]=1;
	}
	return getBit(TIMER,Nr); //TBit[Nr];
}//ENDE SS_Timer

short CPU_sps::SA_Timer(short Nr,short BCD_Zahl, bool Signal)
{	bool Impuls=false;
	Impuls=TImpuls_HighToLowFlanke(Nr,Signal);
  if(!Impuls && !Signal) T_sperren[Nr]=false;
	if(Reset_Timer[Nr]==true)
 	{	TLaufZeit[Nr]=0;
		SetBit(TIMER,Nr,0); //TBit[Nr]=0;
		T_Input[Nr]=false;
		if(Signal) T_sperren[Nr]=true;
	}
 	else if(Impuls && !T_sperren[Nr])
	{ TLaufZeit[Nr]=KT_BcdToDez(BCD_Zahl,Zeitraster[Nr]);
		SetBit(TIMER,Nr,1); // TBit[Nr]=1;
		T_Input[Nr]=true;
		msTLaufZeit[Nr]=(double)TLaufZeit[Nr]*ZeitRasterDouble(Zeitraster[Nr]);
		msTimerStart[Nr]=miliSekunden_double;
	}
	else if(Signal && !T_sperren[Nr])
	{ SetBit(TIMER,Nr,1); //TBit[Nr]=1;
     TLaufZeit[Nr]=0;
	  T_Input[Nr]=false;
	}
	if (TLaufZeit[Nr]==0 && T_Input[Nr])
	{	 SetBit(TIMER,Nr,0);// TBit[Nr]=0;
		 T_Input[Nr]=false;
	}
	return getBit(TIMER,Nr);//TBit[Nr];
}//ENDE SA_Timer


void CPU_sps::Function_Reset_Timer(short Nr, bool Signal)
{ if (Signal)
		Reset_Timer[Nr]=true;
	else
		Reset_Timer[Nr]=false;
}//ENDE Function_Reset_Timer

short CPU_sps::pushStack(int &Op,short &wert)
{  if(StackPointer>0)
	 	 StackPointer--;
	 else
	  return 0; // Stackpointer leer
	 Op=OStack[StackPointer];
   wert=WStack[StackPointer];
   return 1; // Daten gelesen
}//ENDE pushStack(short &Op,short &wert)

void CPU_sps::popStack(int Op,short wert)
{ OStack[StackPointer]=Op;
	WStack[StackPointer]=wert;
	StackPointer++;
} //ENDE popStack(unsigned int Op,short wert)

